
/* TCP/Cytec Matrix Looping Example
   Modify MAX_MTX, MAX_MOD, MAX_RLY to match your hardware
*/

#include <stdio.h>
#include <utility.h>
#include <string.h>
#include <userint.h>
#include <ansi_c.h>
#include <tcpsupp.h>

#include "tcperror.h"
#include "mtxtcp.h"

#define MAX_MTX	1
#define MAX_MOD	2
#define MAX_RLY 8

#define BUFFSIZE 256

#define DELAY 5000

int Use_Defaults =	1;

int Abort, TCP_data_ready;

int TCPCallBack(unsigned, int, int, void *);

main()
{
	char serverName[BUFFSIZE], buffer[BUFFSIZE];
	unsigned TCPhandle;
	int portNumber, status;
	int mtx, mod, rly;
 
	if (Use_Defaults) {
		strcpy(serverName, "10.0.0.144");
		portNumber = 8080;
	}
	else {
		PromptPopup("Server Name?", "Enter Server Name or IP Address",
					 serverName, 255);
		PromptPopup("Port Number?", "Enter Port",
					 buffer, 255);
		portNumber = atoi(buffer);
	}
	Abort =0; 
	TCP_data_ready = 0;
	status = ConnectToTCPServer(&TCPhandle, portNumber, serverName,
								 TCPCallBack, NULL, DELAY);
	
	printf("Initialize.\n");
	status = MtxInitialize(TCPhandle);
	if (status <= 0){
		printf("Failed to initialize\n");
		getchar();
		Abort = 1;
	}
	status = MtxReceive(TCPhandle,buffer);
	if (status <= 0){
		printf("Failed to initialize\n");
		getchar();
		Abort = 1;
	}
	for(mtx=0; mtx<MAX_MTX; mtx++) {
		for (mod=0; mod<MAX_MOD; mod++) {
				for (rly=0; rly<MAX_RLY; rly++) {
					if (Abort)	break;  
					printf("Point %d,%d,%d.\n", mtx,mod,rly);
					
					status = MtxSend(TCPhandle, 'L', mtx, mod, rly);
					if (status<0) {
						TCPerror("Send", status);
						Abort = 1;
					} 
					if (Abort)	break;
					printf("Latched %d, %d, %d\n",mtx,mod,rly);
					status = MtxReceive(TCPhandle,buffer);
					if (status<0) {
						TCPerror("Receive", status);
						Abort =1;
					}  
					if (Abort)	break;
				
					getchar();
				
					
					status = MtxSend(TCPhandle, 'U', mtx, mod, rly);
					if (status<0) {
						TCPerror("Send", status);
						Abort = 1;
					}  
					if (Abort) break;
					printf("Unlatched %d, %d, %d\n",mtx,mod,rly);
					status = MtxReceive(TCPhandle,buffer);
					if (status<0) {
						TCPerror("Receive", status);
						Abort =1;
					}
					if (Abort) break;
				 
					getchar();
					 
				}
		}
	}	 
	
	status = DisconnectFromTCPServer(TCPhandle);
	printf("Done.\n");
}

/*********  TCP Call Back Function ******************************/
int TCPCallBack(unsigned TCPhandle, int event, int errcode, void *CallBackData)
{
	

	switch (event) {
	case	TCP_DATAREADY	:	TCP_data_ready = 1;		 
								break;
	case	TCP_DISCONNECT	:	Abort = 1;
								break;
	}
	return 0;
}

