/* Matrix Formatting Routine for LabWindows/CVI
   Cytec Corp.  1995 */

#include <userint.h>
#include <utility.h>
#include <stdio.h>
#include <string.h>
#include <tcpsupp.h>

#include "mtxtcp.h"

#define DELAY	1000
#define MAXLEN 255 
#define BUFFSIZE 256

char rcvbuff[BUFFSIZE];

extern int TCP_data_ready;


int MtxInitialize(unsigned handle)
{
	int status;

	status = ClientTCPWrite(handle, "V0 73;E0 73;TCPANSWERBACK 1\n", 28, DELAY);
	Delay(1);
	ProcessSystemEvents();
	return status;
}

int MtxSend(unsigned handle, char Op, int Mtx, int Mod, int Rly)
{
	char buff[256];
	int status;

	ProcessSystemEvents();
	sprintf(buff, "%c%d,%d,%d\n", Op, Mtx, Mod, Rly);
	Delay(.5);
	status = 
		ClientTCPWrite(handle, buff, strlen(buff), DELAY);
	Timer();
	while(!TCP_data_ready) {
		ProcessSystemEvents();
		if (Timer()>2.0)
			return 1;
	}
	return status;
}

int MtxReceive(unsigned handle,char *buff)
{
	int status;
	int len, i;
	
	status = ClientTCPRead(handle,rcvbuff, MAXLEN, DELAY);
	if (status >= 0) {
		rcvbuff[status] = 0;
		len = strlen(rcvbuff);
		printf("Response from Device: Len = %d, Data=", len);
		for (i=0; i<25; i++) {
			if (rcvbuff[i]==0) break;
			printf(" %02x", rcvbuff[i]);
		}
		printf("\n");
	}
	TCP_data_ready = 0;
	return status;
}

